<template>
	<v-container>
		<p class="display-1 text-center">Mi perfil</p>
		<v-row justify="space-between">
			<v-col cols="3">
				<p class="font-weight-bold">Folio: {{folio}}</p>
			</v-col>
			<v-col cols="3">
				<p class="font-weight-bold text-end">Fecha de registro: {{registrationDate}}</p>			
			</v-col>
		</v-row>
		<ProfilePersonalData class="mb-5" />
		<ProfileAddressData class="mb-5" />
		<ProfileScholarData />
		<v-row class="mt-5" justify="center">
			<v-btn dark color="blue" @click="openFormPassword">Actualizar contraseña</v-btn>
		</v-row>
		<FormChangePass :showForm="formPass" />
		<Navigation />
	</v-container>
</template>

<script>
import Navigation from "@/components/Navigation.vue";
import ProfilePersonalData from "@/components/student/ProfilePersonalData";
import ProfileAddressData from "@/components/student/ProfileAddressData";
import ProfileScholarData from "@/components/student/ProfileScholarData";
import FormChangePass from "@/components/student/FormChangePass";
import gql from "graphql-tag";
import { mapMutations, mapState } from "vuex";
import EventBus from "../../bus";

export default {
	name: "Profile",
	components: {
		FormChangePass,
		Navigation,
		ProfilePersonalData,
		ProfileAddressData,
		ProfileScholarData
	},
	data: () => ({
		folio: "",
		registrationDate:"",
		formPass: false
	}),
	computed: {
		...mapState(["userData"])
	},
	methods: {
		...mapMutations(["saveUserData"]),

		// Obtiene el folio
		async getFolio() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								serial
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});
				this.folio = data.findStudent.serial;
			} catch (error) {}
		},
		// Obtiene la fecha de registro del usuario
		async getRegistrationDate(){
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							getLastScholarship(curp: $curp) {
								registrationDate
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});
				const date = new Date(parseInt(data.getLastScholarship.registrationDate));
				this.registrationDate = `${date.getDate()}/${date.getMonth()+1}/${date.getFullYear()}`
			} catch (error) { }
		},
		// Muestra el formulario de cambio de contraseña
		openFormPassword() {
			this.formPass = true;
		}
	},
	created() {
		this.saveUserData();
		this.getFolio();
		this.getRegistrationDate();
	},
	mounted() {
		// Cierra el form de actualizar contraseña
		EventBus.$on("closeFormPass", () => {
			this.formPass = false;
		});
	}
};
</script>

<style scope>
.back {
	background-color: #72a051;
}
</style>